<?php
namespace Incoviba\Service\Venta;

use DateTimeImmutable;
use DateInterval;
use IntlDateFormatter;
use Incoviba\Repository;
use Incoviba\Model;

class Cuota
{
    public function __construct(
        protected Repository\Venta\Cuota $cuotaRepository,
        protected Pago $pagoService,
        protected Repository\Venta\TipoPago $tipoPagoRepository
    ) {}

    public function pendientes(): array
    {
        $cuotas = $this->cuotaRepository->fetchPendientes();
        $cuotas_pendientes = [];
        $today = new DateTimeImmutable();
        $formatter = new IntlDateFormatter('es_ES');
        $formatter->setPattern('EEEE dd');
        foreach ($cuotas as $cuota) {
            $date = new DateTimeImmutable($cuota['fecha']);
            $day = clone $date;
            $weekday = $date->format('N');
            if ($weekday > 5) {
                $diff = 7 - $weekday + 1;
                $day = $day->add(new DateInterval("P{$diff}D"));
            }
            $cuotas_pendientes []= [
                'id' => $cuota['cuota_id'],
                'venta_id' => $cuota['venta_id'],
                'Proyecto' => $cuota['Proyecto'],
                'Departamento' => $cuota['Departamento'],
                'Valor' => $cuota['Valor'],
                'Dia' => $formatter->format($day),
                'Numero' => $cuota['Numero'],
                'Propietario' => $cuota['Propietario'],
                'Banco' => $cuota['Banco'],
                'Fecha Cheque' => $date->format('d-m-Y'),
                'Vencida' => $today->diff($date)->days,
                'Fecha ISO' => $date->format('Y-m-d')
            ];
        }
        return $cuotas_pendientes;
    }
    public function depositadas(): array
    {
        $cuotas = $this->cuotaRepository->fetchDepositadas();
        $cuotas_depositadas = [];
        $today = new DateTimeImmutable();
        $formatter = new IntlDateFormatter('es_ES');
        $formatter->setPattern('EEEE dd');
        foreach ($cuotas as $cuota) {
            $date = new DateTimeImmutable($cuota['fecha']);
            $deposito = new DateTimeImmutable($cuota['Fecha Depositada']);
            $cuotas_depositadas []= [
                'id' => $cuota['cuota_id'],
                'venta_id' => $cuota['venta_id'],
                'Proyecto' => $cuota['Proyecto'],
                'Departamento' => $cuota['Departamento'],
                'Valor' => $cuota['Valor'],
                'Numero' => $cuota['Numero'],
                'Propietario' => $cuota['Propietario'],
                'Banco' => $cuota['Banco'],
                'Fecha Cheque' => $date->format('d-m-Y'),
                'Fecha ISO' => $date->format('Y-m-d'),
                'Fecha Depositada' => $deposito->format('d-m-Y')
            ];
        }
        return $cuotas_depositadas;
    }
    public function getVigenteByPie(int $pie_id): array
    {
        return $this->cuotaRepository->fetchVigenteByPie($pie_id);
    }

    public function add(array $data): Model\Venta\Cuota
    {
        $tipoPago = $this->tipoPagoRepository->fetchByDescripcion('cheque');
        $fields = array_fill_keys([
            'fecha',
            'banco',
            'valor',
            'identificador'
        ], 0);
        $filtered_data = array_intersect_key($data, $fields);
        $pago_data = array_merge($filtered_data, ['tipo' => $tipoPago->id]);
        $pago = $this->pagoService->add($pago_data);
        $data['pago'] = $pago->id;
        $data['estado'] = $pago->currentEstado->tipoEstadoPago->id;
        $fields = array_fill_keys([
            'pie',
            'fecha',
            'valor',
            'estado',
            'banco',
            'uf',
            'pago',
            'numero'
        ], 0);
        $filtered_data = array_intersect_key($data, $fields);
        $mapped_data = $filtered_data;
        $mapped_data['valor_$'] = $mapped_data['valor'];
        unset($mapped_data['valor']);
        $cuota = $this->cuotaRepository->create($mapped_data);
        $this->cuotaRepository->save($cuota);
        return $cuota;
    }
}
